<?php
	/*
	Plugin Name: NoShop
	Plugin URI: http://jesper.angelo.net/wordpress/noshop/
	Description: NoShop. Allows you to put a list of items on a structured list with pictures, replacing the need for a real shopping cart.
	Version: 0.4
	Author: Jesper Angelo
	Author URI: http://jesper.angelo.net/
	License: GPL2
	*/
	/*  Copyright 2010  JESPER ANGELO  (email : jesper@angelo.net)

		This program is free software; you can redistribute it and/or modify
		it under the terms of the GNU General Public License, version 2, as
		published by the Free Software Foundation.

		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
		GNU General Public License for more details.

		You should have received a copy of the GNU General Public License
		along with this program; if not, write to the Free Software
		Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
	*/

	global $wpdb;
	$wpdb->show_errors();

	register_activation_hook(__FILE__,'NoShop::noshop_activate');

	global $noshop_db_version;
	$noshop_db_version = "0.4";

	if (!class_exists("NoShop")) {

		class NoShop {
			//constructor
			function NoShop()
			{
				// Hook up Actions and Filters
				//if (isset($noshop_plugin)) {
					//Actions
					add_action('wp_footer', 'NoShop::Products');
					add_action('wp_head', 'NoShop::CSS');

					//Filters
					add_filter( 'the_content', 'NoShop::ShowTable' );
					add_action('admin_menu', 'NoShop::PluginMenu');
				//}
			}

			// Install part: Create table for products (or check if it's there at least)
			public static function noshop_activate() {
				global $wpdb;
				global $noshop_db_version;

				// First the Product Table
				$table_name = $wpdb->prefix . "noshop_products";
				if($wpdb->get_var("show tables like '$table_name'") != $table_name) {
					$sql = "CREATE TABLE " . $table_name . " (
						id mediumint(9) NOT NULL AUTO_INCREMENT,
						time bigint(11) DEFAULT '0' NOT NULL,
						category tinytext NOT NULL,
						title tinytext NOT NULL,
						description text NOT NULL,
						url VARCHAR(250) NOT NULL,
						imgurl VARCHAR(250) NOT NULL,
						UNIQUE KEY id (id),
						PRIMARY KEY primarykey (id)
					);";
					require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
					dbDelta($sql);
					$rows_affected = $wpdb->insert( $table_name, array(
												'time' => current_time('mysql'),
												'category' => 'Stuff',
												'title' => 'Tin-Tin',
												'description' => 'Full-size Tin-Tin figure in molded plastic!',
												'url' => 'http://tintin.org',
												'imgurl' => 'http://tintin.org/logo.png'
												) );
				} // End if()

				// Second some Product Specs
				$table_name = $wpdb->prefix . "noshop_product_specs";
				if($wpdb->get_var("show tables like '$table_name'") != $table_name) {
					$sql = "CREATE TABLE " . $table_name . " (
						id mediumint(9) NOT NULL AUTO_INCREMENT,
						product_id mediumint(9) NOT NULL,
						time bigint(11) DEFAULT '0' NOT NULL,
						spectitle tinytext NOT NULL,
						specvalue text NOT NULL,
						UNIQUE KEY id (id)
					);";
					require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
					dbDelta($sql);
					$rows_affected = $wpdb->insert( $table_name, array(
						'product_id' => 1,
						'time' => current_time('mysql'),
						'spectitle' => 'Plastics',
						'specvalue' => 'Good solid plastics.'
					) );
				} // End if()

				add_option("noshop_db_version", $noshop_db_version);
			} // End noshop_activate()

			// This just echoes the chosen line, we'll position it later
			public function Products() {
				$wpdb->print_error();
			} // End Products()


			// Now we set that function up to execute when the admin_footer action is called

			// We need some CSS to position the paragraph
			public static function CSS() {
			  // This makes sure that the posinioning is also good for right-to-left languages
	//          $x = ( is_rtl() ) ? 'left' : 'right';
				echo "<link rel=\"stylesheet\" href=\"/wp-content/plugins/noshop/noshop.css\" \>";
			} // End CSS()

			public static function ShowTable($content) {
				$cat = "";
				$search = "@\s*\[NoShop ([^\]]+)\]\s*@i";
				if(preg_match_all($search, $content, $matches)) {
					if(is_array($matches)) {
						foreach($matches[1] as $cat) {
							// Get the data from the tag
							//print("\n<br />\n");
							//print_r($cat);
							//$content = str_replace ($search, $replace, $content);
							$content = preg_replace( "$search", NoShop::createtable($cat), $content );
							//$content .= "<h2>THAT WAS CATEGORY: ".$cat."</h2>\n";
						}
					}
				}

				//$content = str_replace( "[NoShop]", "THIS?", $content );
				return $content;
			} // End ShowTable($content)

			public function createtable($cat) {
				// get options
				$options = get_option('noshop_options');
				if($wptouch)	$width=$options['wptouchwidth'];
				else			$width=$options['width'];

				$widthparam = " width=".$width." style=\"width:".$width."px;\" ";

				global $table_prefix, $wpdb;
				$table_name = $wpdb->prefix . "noshop_products";

				if($cat<>"")
					$sql = $wpdb->prepare( "SELECT * FROM $table_name WHERE category=%s", $cat );
				else
					$sql = $wpdb->prepare( "SELECT * FROM $table_name" );

				$myrows = $wpdb->get_results( $sql );
				foreach ($myrows as $myrows) {

					$ret .= "".
							"				<div class=noshop-product>".
							"				 <div class=noshop-product-imagebox $widthparam>".
							"				   <a href=\"" . $myrows->url . "\" />".
							"					 <img class=noshop-product-image $widthparam src=\"" . $myrows->imgurl . "\" />".
							"				   </a>".
							"				 </div>".
							"				 <div class=noshop-product-textbox>".
							"				   <a href=\"" . $myrows->url . "\" />".
							"				     <div class=noshop-product-title>" . $myrows->title . "</div>".
							"				   </a>".
							"				   <div class=noshop-product-desc>".
							"					   " . $myrows->description . "".
							"				   </div>".
							NoShop::createsubtable($myrows->id).
							"				 </div>".
							"				</div>";
				} // End foreach

				return $ret;

			} // End createtable()

			public function createsubtable($id) {
				global $table_prefix, $wpdb;
				$table_name = $wpdb->prefix . "noshop_product_specs";

				$myrows = $wpdb->get_results( "SELECT * FROM " . $table_name . " WHERE product_id=" . intval($id) ."" );
				foreach ($myrows as $myrows) {

					$ret .= "".
							"				   <div class=noshop-product-spec>".
							"					 <div class=noshop-product-spec-var>".$myrows->spectitle."</div>".
							"					 <div class=noshop-product-spec-val>".$myrows->specvalue."</div>".
							"				   </div>";
				} // End foreach

				return $ret;

			} // End createsubtable()













			// //////////////////////////////////////////////////////////////////////////////////////////////////////////// //
			//                                                                                                              //
			//   OPTION PAGE                                                                                                //
			//                                                                                                              //
			// //////////////////////////////////////////////////////////////////////////////////////////////////////////// //
			public static function OptionPage() {
				// get options
				$options = $newoptions = get_option('noshop_options');

				$dir_name = '/wp-content/plugins/noshop';
				$url = get_bloginfo('wpurl');
				$myURL = $url.$dir_name.'/';
//				printf( __('My URL: %s.', 'noshop'), $myURL);

				// Check for permissions
				if (!current_user_can('manage_options'))  {
					wp_die( __('You do not have sufficient permissions to access this page.') );
				}

				global $table_prefix, $wpdb;
				$table_name = $wpdb->prefix . "noshop_products";
				$subtable_name = $wpdb->prefix . "noshop_product_specs";

				// if submitted, process results
				if ( isset($_POST["noshop_submit"]) && $_POST["noshop_submit"]=="options") {
					echo "*** Updating options!!! ***";
					$newoptions['width'] = strip_tags(stripslashes($_POST["width"]));
					$newoptions['wptouchwidth'] = strip_tags(stripslashes($_POST["wptouchwidth"]));
					if ($_POST["visibleerrors"]=="on") {
						$newoptions['visibleerrors'] = "true";
					} else {
						$newoptions['visibleerrors'] = "";
					}

					// //////////////////////////////////////////////////////////// //
					// check if installed (hook is not called if used as mu-plugin) //
					// //////////////////////////////////////////////////////////// //
					//$wtemp = get_option('noshop_width');
					//if( empty($wtemp) ){
					//	echo "WHAT NOT INST?!? ****";
					//	NoShop::noshop_activate();
					//}
				}

				// if product selected, save selection persistantly as an option
				if ( isset($_POST["noshop_submit"]) && $_POST["noshop_submit"]=="productselect") {
					$newoptions['selectproduct'] = strip_tags(stripslashes($_POST["selectproduct"]));

					// If needed, add a product
					if ($_POST["addprod"]=="on") {
						$wpdb->query(
							$wpdb->prepare( "INSERT INTO $table_name ( category, title, description, url, imgurl ) VALUES ( %s, %s, %s, %s, %s )",
											array('', 'New Product', 'Please type a description', 'http://wordpress.org/', 'http://s.wordpress.org/about/images/wordpress-logo-notext-bg.png') )
						);
					}

					// Update selected product option
					update_option('noshop_selectproduct', $_POST['noshop_selectproduct']);
				}

				// any changes? save!
				if ( $options != $newoptions ) {
					$options = $newoptions;
					update_option('noshop_options', $options);
				}



				// ////////////////////////////////////////////////////////// //
				// option handling - db interaction                           //
				// ////////////////////////////////////////////////////////// //

				// if options form was sent, process those...
				if ( isset($_POST["noshop_submit"]) && $_POST["noshop_submit"]=="productupdate") {
					//if( isset($_POST['action']) && $_POST['action'] == "updateoptions" ){

					// If needed, add a row
					if ($_POST["addspec"]=="on") {
						$wpdb->query(
							$wpdb->prepare( "INSERT INTO $subtable_name ( product_id, spectitle, specvalue ) VALUES ( %d, %s, %s )",
											array($options['selectproduct'], 'Specification', 'Value') )
						);
					}

					// Update the product info
					$sql = $wpdb->prepare( "UPDATE $table_name SET category=%s, title=%s, description=%s, url=%s, imgurl=%s WHERE id=%d",
											array(
												$_POST[prodcat], $_POST[prodtitle], $_POST[proddesc],
												$_POST[produrl], $_POST[prodimgurl],
												$options['selectproduct']
											)
										);
					$wpdb->query( $sql );
					//echo "SQL: $sql<br />";

					// Update the product spec
					foreach($_POST["spec"] as $spec) {
						if($spec[title]!="") {
							$sql = $wpdb->prepare( "UPDATE $subtable_name SET spectitle=%s, specvalue=%s WHERE product_id=%d AND id=%d",
													array($spec[title], $spec[value], $options['selectproduct'], $spec[id] ) );
						} else {
							echo "One specification line item being deleted!<br />";
							$sql = $wpdb->prepare( "DELETE FROM $subtable_name WHERE product_id=%d AND id=%d",
													array($options['selectproduct'], $spec[id] ) );
						}
						$wpdb->query( $sql );
					}


				}


				// ////////////////////////////////////////////////////////// //
				// Options Form
				// ////////////////////////////////////////////////////////// //

				echo'<form method="post" action="'.get_bloginfo('wpurl').'/wp-admin/options-general.php?page=noshop/noshop.php">';
				echo '<div class="wrap"><p><h2>'.__('NoShop Options', 'noshop').'</h2><p>';
				// settings
				echo '<table class="form-table">';
				// width
				echo '<tr valign="top"><th scope="row">'.__('Product Display Width', 'noshop').'</th>';
				echo '<td><input type="text" name="width" value="'.$options['width'].'" size="10"></input><br />'.__('Maximum width of pictures in pixels', 'noshop').'</td></tr>';
				// wptouchwidth
				echo '<tr valign="top"><th scope="row">'.__('Product Display Width in WPtouch', 'noshop').'</th>';
				echo '<td><input type="text" name="wptouchwidth" value="'.$options['wptouchwidth'].'" size="10"></input><br />'.__('Maximum width of pictures in WPtouch mode', 'noshop').'</td></tr>';
				// errors
				echo '<tr valign="top"><th scope="row">'.__('Show DB Errors', 'noshop').'</th>';
				if (isset($options['visibleerrors']) && !empty($options['visibleerrors'])) {
						$checked = " checked=\"checked\"";
				} else {
						$checked = "";
				}
				echo '<td><input type="checkbox" name="visibleerrors" value="on"'.$checked.' />'.__('Attempt to show all database related errors.', 'noshop').'</td></tr>';
				echo '</table>';

				// SUBMIT
				echo '<input type="hidden" name="noshop_submit" value="options"></input>';
				echo '<p class="submit"><input type="submit" value="'.__('Update Option &raquo;', 'noshop').'"></input></p>';
				echo "</div>";
				echo '</form>';



				// ////////////////////////////////////////////////////////// //
				// Product selection
				// ////////////////////////////////////////////////////////// //

				$product_count = $wpdb->get_var($wpdb->prepare("SELECT COUNT(*) FROM " . $table_name));
				echo'<form method="post" action="'.get_bloginfo('wpurl').'/wp-admin/options-general.php?page=noshop/noshop.php">';
				echo '<div class="wrap">';
				echo '<p>';
				echo '	Total number of items in database: ' . $product_count . '<br />';
				echo '	Currently selected items ID: ' . $options['selectproduct'] . '<br />';
				echo '</p>';
				$myrows = $wpdb->get_results( "SELECT * FROM " . $table_name );
				echo '<select name="selectproduct">';
				foreach ($myrows as $myrows) {
					echo '<option value=' . $myrows->id . ''. ($myrows->id==$options['selectproduct']?' SELECTED':'') . '>' . $myrows->category . ' | ' . $myrows->title . '';
				}
				echo '</select>';

				// NEW?
				echo '<tr valign="top"><th scope="row">'.__('Add a new product?', 'noshop').'</th>';
				echo '<td>';
				echo '<input type="checkbox" name="addprod" value="on" />';
				echo '</td></tr>';

				// SUBMIT
				echo '<input type="hidden" name="noshop_submit" value="productselect"></input>';
				echo '<p class="submit"><input type="submit" value="'.__('Select Product &raquo;', 'noshop').'"></input></p>';
				echo "</div>";
				echo '</form>';


				// ////////////////////////////////////////////////////////// //
				// Products Form
				// ////////////////////////////////////////////////////////// //

				echo'<form method="post" action="'.get_bloginfo('wpurl').'/wp-admin/options-general.php?page=noshop/noshop.php">';

				echo '<div class="wrap">';

				$mycurrentprod = $wpdb->get_results( "SELECT * FROM " . $table_name . " WHERE ID=".intval($options['selectproduct']) );
				// settings
				echo '<table class="form-table">';

				// Category
				echo '<tr valign="top"><th scope="row">'.__('Category', 'noshop').'</th>';
				echo '<td><input type="text" name="prodcat" value="'.$mycurrentprod[0]->category.'" size="15"></input>';
				echo '</td></tr>';

				// Title
				echo '<tr valign="top"><th scope="row">'.__('Title', 'noshop').'</th>';
				echo '<td><input type="text" name="prodtitle" value="'.$mycurrentprod[0]->title.'" size="35"></input>';
				echo '</td></tr>';

				// URL
				echo '<tr valign="top"><th scope="row">'.__('Reference URL', 'noshop').'</th>';
				echo '<td><input type="text" name="produrl" value="'.$mycurrentprod[0]->url.'" size="80"></input>';
				echo '</td></tr>';

				// Image URL
				echo '<tr valign="top"><th scope="row">'.__('URL to Product Image', 'noshop').'</th>';
				echo '<td><input type="text" name="prodimgurl" value="'.$mycurrentprod[0]->imgurl.'" size="80"></input>';
				echo '</td></tr>';

				// Description
				echo '<tr valign="top"><th scope="row">'.__('Product Description', 'noshop').'</th>';
				echo '<td><textarea name="proddesc" rows=6 cols=80>'.$mycurrentprod[0]->description.'</textarea>';
				echo '</td></tr>';

				echo '</table>';


				$mycurrentspecs = $wpdb->get_results( "SELECT * FROM " . $subtable_name . " WHERE product_id=".intval($options['selectproduct']) );
				echo '<table class="form-table">';
				foreach ($mycurrentspecs as $mycurrentspecs) {
					// Title
					echo "<tr valign=\"top\"><th scope=\"row\">".__('Specification', 'noshop')."</th>";
					echo "<td>";
					echo "<input type=\"text\" name=\"spec[".$mycurrentspecs->id."][title]\" value=\"".$mycurrentspecs->spectitle."\" size=\"15\" />";
					echo "<input type=\"text\" name=\"spec[".$mycurrentspecs->id."][value]\" value=\"".$mycurrentspecs->specvalue."\" size=\"35\" />";
					echo "<input type=\"hidden\" name=\"spec[".$mycurrentspecs->id."][id]\" value=\"".$mycurrentspecs->id."\" />";
					echo "</td></tr>";
				}

				// Extra?
				echo '<tr valign="top"><th scope="row">'.__('Add Specification Line Item?', 'noshop').'</th>';
				echo '<td>';
				echo '<input type="checkbox" name="addspec" value="on" />';
				echo '</td></tr>';

				echo '</table>';

				// SUBMIT
				echo '<input type="hidden" name="noshop_submit" value="productupdate"></input>';
				echo '<p class="submit"><input type="submit" value="'.__('Update Product &raquo;', 'noshop').'"></input></p>';
				echo "</div>";
				echo '</form>';


				// ////////////////////////////////////////////////////////// //
				// Using Information
				// ////////////////////////////////////////////////////////// //

				echo '<div class="wrap"><p><h2>'.__('Using noshop', 'noshop').'</h2><p>';
				echo 'Add the tag [NoShop &lt;category&gt;] to any page or post to show the list of items in that category.';
				echo '</p></div>';

			} // End OptionPage()

			public static function PluginMenu() {
				add_options_page('NoShop Plugin Options', 'No Shop!', 'manage_options', 'noshop/noshop.php', 'NoShop::OptionPage');
			}


		} //End Class NoShop

	} // End if (!class_exists("NoShop"))


	// ////////////////////////////////////////////////////////// //
	// Kick-off: Load instance if class created correctly
	// ////////////////////////////////////////////////////////// //

	if (class_exists("NoShop")) {
		$noshop_plugin = new NoShop();
	}

?>